/*
//TODO: agregar hook upgrade/install

Donkeyfire - an MLDonkey Extension for Firefox, by Arturo 'Buanzo' Busleiman <buanzo@buanzo.com.ar>
License: Dual GNU GPL and MPL
*/
/*
NOTES:

	count(/html/body/div/table[@id='downloaderTable']/tbody/tr)

*/

function objdump(arr,level) {
var dumped_text = "";
if(!level) level = 0;

//The padding given at the beginning of the line.
var level_padding = "";
for(var j=0;j<level+1;j++) level_padding += "    ";

if(typeof(arr) == 'object') { //Array/Hashes/Objects
 for(var item in arr) {
  var value = arr[item];

  if(typeof(value) == 'object') { //If it is an array,
   dumped_text += level_padding + "'" + item + "' ...\n";
   dumped_text += dump(value,level+1);
  } else {
   dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
  }
 }
} else { //Stings/Chars/Numbers etc.
 dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
}
return dumped_text;
}

var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
						.getInterface(Components.interfaces.nsIWebNavigation)
						.QueryInterface(Components.interfaces.nsIDocShellTreeItem)
						.rootTreeItem
						.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
						.getInterface(Components.interfaces.nsIDOMWindow) 

var gBrowser = mainWindow.document.getElementById("content");
var donkeybrowser = null;
var donkeyprogress = null;
var donkeyStatuslabel = null;
var postLoadCmd = "";
var df_intervalid = null;

var donkeyfire = {
	
	
	
	onLoad: function() {
		//DEBUG:
		dump("[DF] onLoad\n");
		this.strings = document.getElementById("donkeyfire-strings");
		
		donkeyStatuslabel = document.getElementById("status-bar-donkeyfire-label-1");
		donkeyprogress = document.getElementById("status-bar-donkeyfire-progress-1");
		// configure donkeybrowser (XUL iframe, see browserOverlay.xul).
		// we use this to get the DOM of an arbitrary page
		// without showing it. better than responseXML :P
		donkeybrowser = document.getElementById("status-bar-donkeyfire-iframe-1");
		if (donkeybrowser) {
			dump("[DF] status-bar-donkeyfire-iframe-1 element found. Setting attributes.\n");
			donkeybrowser.style.height = "0px";
			donkeybrowser.webNavigation.allowAuth = false;
			donkeybrowser.webNavigation.allowImages = false;
			donkeybrowser.webNavigation.allowJavascript = false;
			donkeybrowser.webNavigation.allowMetaRedirects = true;
			donkeybrowser.webNavigation.allowPlugins = false;
			donkeybrowser.webNavigation.allowSubframes = false;
			donkeybrowser.addEventListener("DOMContentLoaded", function (e) {donkeyfire.donkeybrowser_onPageLoad(e); }, true);
		} else {
			dump("[DF] status-bar-donkeyfire-iframe-1 NOT FOUND. Showing alert.\n");
			alert('Unable to get a reference to XUL:iframe id=status-bar-donkeyfire-iframe-1. Please, notify the author using the official forum (http://donkeyfire.mozdev.org for details).');
		}
		if (df_getCharPref("mldonkey_url") != "") {
			donkeyfire_obtainDownloadStatus();
			dump("[DF] Interval = "+df_getIntPref("update_interval")+"\n");
			df_intervalid = window.setInterval(donkeyfire_obtainDownloadStatus,df_getIntPref("update_interval")*1000);
		} else
			alert('You should set your MLDonkey server URL via Tools -> Addons -> DonkeyFire Preferences');
		//donkeyfire.check_external_requirements();
		this.initialized = true;
		
/*		if (this.initialized==true) {
			if (document.getElementById("appcontent"))
				document.getElementById("appcontent").addEventListener("DOMContentLoaded", function(e) { donkeyfire.onPageLoad(e); }, true);
		}*/
	},

	onUnload: function() {
		//DEBUG:
		dump("[DF] onUnload\n");
		
	},
	
/*	onPageLoad: function(aEvent) {
		var doc = aEvent.originalTarget;
		var url = doc.location.href;
		if (aEvent.originalTarget.nodeName == "#document") { // ok, it's a real page, let's do our magic
			dump("[PI] onPageLoad - "+url+"\n");
		}
	}, */
	
	/* STATUSBAR FUNCTIONS */
	statusbar_onClick: function(Event) {
		dump("[DF] Statusbar clicked. Button = "+Event.button+"\n");
		if (Event.button == 0) // normal click, main mouse button
			if (!Event.ctrlKey)
				donkeyfire_obtainDownloadStatus();
			else { // click with ctrl key pressed
				var win = window.openDialog("chrome://donkeyfire/content/progressDialog.xul","Donkeyfire - MLDonkey Progress Dialog","chrome=yes,modal=yes,centerscreen=yes");
			}
		else if (Event.button == 2) { // secondary mouse button
			var mytab = gBrowser.addTab(df_getCharPref("mldonkey_url"));
			gBrowser.selectedTab = mytab;
		}
	},
	
	donkeybrowser_onPageLoad: function(aEvent) {
		dump("[DF] onPageLoad en donkeybrowser\n");
		var doc = aEvent.originalTarget;
		dump("[DF] hasTable = "+doc.getElementById("selectForm")+"\n");
		if (doc.getElementById("selectForm")==null) {
			donkeyfire.statusbar_setStatus("MLDonkey Server seems down. Please check.",null);
			donkeyfire.progressbar_visible(false);
			return;
		}
		var url = doc.location.href;
		if (aEvent.originalTarget.nodeName == "#document") { // ok, it's a real page, let's do our magic
			//dump("[DF] URL = "+url+"\n");
			//dump("[DF] DOC = "+doc+"\n");
			//dump("[DF] postLoadCmd = "+postLoadCmd+"\n");
			
			if (postLoadCmd == "dlstatus") {
				var xtotal = getXString(doc,"/html/body/div[1]/form[@id='selectForm']/table/tbody/tr[1]/td/table/tbody/tr/td[1]");
				dump("[DF] xtotal = "+xtotal+"\n");
				if (xtotal == "") { // No Downloads. Update statusbar.
					dump("[DF] NO Downloads.\n");
					donkeyfire.statusbar_setStatus("No downloads",null);
					donkeyfire.progressbar_visible(false);
				} else { // We have some downloads going on, let's get some extra info
					dump("[DF] We have downloads. Getting more info.\n");
					/*
					first % /html/body/div[1]/form[@id='selectForm']/table/tbody/tr[2]/td/table/tbody/tr[2]/td[9]
					2nd   % /html/body/div[1]/form[@id='selectForm']/table/tbody/tr[2]/td/table/tbody/tr[3]/td[9]
					cantidad elementos = count(/html/body/div[1]/form[@id='selectForm']/table/tbody/tr[2]/td/table/tbody/tr) - 1
					*/
					
					// Yes, I could retrieve this value using regexp in xtotal, but xpath is faster I guess
					var xelements = getXNumber(doc,"count(/html/body/div[1]/form[@id='selectForm']/table/tbody/tr[2]/td/table/tbody/tr)")-1;
					var xtotalprogress = 0;
					var ignored_items = 0;
					try {
						var ignorePaused = df_getBoolPref("ignore_paused");
					} catch(ex) {
						dump ("[DF] Ignore Paused Transfers not-declared. Assuming false.\n");
						df_setBoolPref("ignore_paused",false);
						var ignorePaused = false;
					}
					dump ("[DF] Ignore Paused Transfers = "+ignorePaused+"\n");
					for (var i = 0; i < xelements; i++) {
						var rate = getXString(doc,"/html/body/div[1]/form[@id='selectForm']/table/tbody/tr[2]/td/table/tbody/tr["+(2+i)+"]/td[16]");
						dump("[DF] Rate = "+rate+"\n");
						if ((rate=="Paused") && (ignorePaused)) {
							dump("[DF] Ignoring this item...\n");
							ignored_items = ignored_items + 1;
							continue;
						}
						var percent = getXNumber(doc,"/html/body/div[1]/form[@id='selectForm']/table/tbody/tr[2]/td/table/tbody/tr["+(2+i)+"]/td[9]");
						dump("[DF] percent = "+percent+" - "+i+"\n");
						xtotalprogress = xtotalprogress + percent;
						dump("[DF] XTotalProgress = "+xtotalprogress+" - "+i+"\n");
					}
					dump("[DF] Total items   = "+xelements+"\n");
					dump("[DF] Ignored items = "+ignored_items+"\n");
					if (xelements==ignored_items) {
						donkeyfire.progressbar_visible(false);
						donkeyfire.statusbar_setStatus("No downloads",null);
					} else {
						var avgProgress = xtotalprogress / (xelements-ignored_items);
						dump("[DF] Average Progress = "+avgProgress+"\n");
						donkeyfire.statusbar_setStatus(xtotal,avgProgress);
						donkeyfire.progressbar_visible(true);
					}
				}
				//donkeyfire.statusbar_setStatus("Sandunga","100");
			} else {
				dump("[DF] Unknown command. Doing nothing\n");
			}
			// reset
			postLoadCmd="";
		}
	},
	
	progressbar_visible: function(visible) {
		if (visible==false) {
			donkeyprogress.hidden=true;
		} else {
			donkeyprogress.hidden=false;
		}
	},
	
	statusbar_setStatus: function(labelText,progressValue) {
		if (progressValue != null) donkeyprogress.value = progressValue;
		if (labelText != null) donkeyStatuslabel.value = labelText;
	},
	
/*	check_external_requirements: function() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var branch = prefs.getBranch("network.http.");
		try {
			var n = branch.getIntPref("phishy-userpass-length");
		} catch(ex) {
			alert('For Donkeyfire to work, the network.http.phishy-userpass-length configuration parameter must be 255 (maybe less). Use about:config to set it up.');
		}
		if (n < 255)
			alert('For Donkeyfire to work without annoying you, the network.http.phishy-userpass-length configuration parameter must be 255 (maybe less, depending on your mldonkey username/password length). Use about:config to set it up. Currently, it has this value: '+n);
	},*/
	
};

window.addEventListener("load", function(e) { donkeyfire.onLoad(e); }, false);
window.addEventListener("unload", function(e) { donkeyfire.onUnload(e); }, false);
//window.addEventListener("click", function(e) { donkeyfire.onClick(e); }, false);

/* DOM functions */
function donkeyfire_loadURI(url,_postLoadCmd) {
	const unicodeConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	unicodeConverter.charset = "UTF-8";
	
	// we need to convert the header getAuthHeader() returns to an InputStream.
	var authHeader = donkeyfire_getAuthHeader();
	if (authHeader == null)
		headerStream=null;
	else
		headerStream=unicodeConverter.convertToInputStream(authHeader);
	dump("[DF] About to loadURI\n");
	donkeybrowser.webNavigation.loadURI(url,Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE,null,null,headerStream);
	postLoadCmd = _postLoadCmd;
}

function getXString(doc,xp) {
	return(doc.evaluate(xp,doc,null,XPathResult.STRING_TYPE,null).stringValue);
}

function getXNumber(doc,xp) {
	return(doc.evaluate(xp,doc,null,XPathResult.NUMBER_TYPE,null).numberValue);
}

function getXObj(doc,xp) {
	return(doc.evaluate(xp,doc,null,XPathResult.FIRST_ORDERED_NODE_TYPE,null).singleNodeValue);
}

/* Preferences Functions */
function df_getCharPref(pref) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);
	var branch = prefs.getBranch("extensions.donkeyfire.");
	return(branch.getCharPref(pref));
}

function df_getBoolPref(pref) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);
	var branch = prefs.getBranch("extensions.donkeyfire.");
	return(branch.getBoolPref(pref));
}

function df_getIntPref(pref) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);
	var branch = prefs.getBranch("extensions.donkeyfire.");
	return(branch.getIntPref(pref));
}

function df_setBoolPref(pref,val) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);
	var branch = prefs.getBranch("extensions.donkeyfire.");
	branch.setBoolPref(pref,val);
	dump("[DF] Preference Set: "+pref+" = "+val+"\n");
}


/* General Functions */
function donkeyfire_getMLCmdUrl(cmd) {
var url = df_getCharPref("mldonkey_url");
if (url == "") { 
	alert("You should open DonkeyFire's Options dialog.");
	return("");
}
dump("[DF donkeyfire_getMLCmdUrl] URL FROM PREF = "+url+"\n");
/* var username = df_getCharPref("mldonkey_user");
dump("                            Username = "+username+"\n");
var password = df_getCharPref("mldonkey_pwd");
//dump("[DF] Password = "+password+"\n");
url = url.replace('http://','http://'+username+':'+password+'@');
url = url.replace('https://','https://'+username+':'+password+'@');
*/
url = url + "/submit?q="+cmd;
dump("[DF] MLURL    = "+url+"\n");
return(url);
}

function donkeyfire_getAuthHeader() {
var username = df_getCharPref("mldonkey_user");
dump("                            Username = "+username+"\n");
if (username == "") return null;
var password = df_getCharPref("mldonkey_pwd");
//dump("[DF] Password = "+password+"\n");
var headerString="Authorization: Basic " + window.btoa(username+":"+password) + "\r\n";
dump("[DF] AuthHeader = "+headerString);
return(headerString);
}

function removeNL(s){ 
  return s.replace(/[\n\r\t]/g,''); 
}

function donkeyfire_obtainDownloadStatus() {
	var mlurl = donkeyfire_getMLCmdUrl("vd");
	if (!donkeybrowser)
		donkeybrowser = document.getElementById("status-bar-donkeyfire-iframe-1");
	dump("[DF donkeyfire_obtainDownloadStatus] Obtained MLURL="+mlurl+"\n");
	//alert("MLURL: "+mlurl);
	// once the page is loaded, the DOMContentLoaded event triggers donkeyfire.onPageLoad(). That's where the magic begins
	if (mlurl != "") donkeyfire_loadURI(mlurl,"dlstatus");
}
